JUCE: LookAndFeel_V4 Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Classes | Public Member Functions | Static Public Member Functions | List of all members
LookAndFeel_V4 Class Reference
juce_gui_basics » lookandfeel

The latest JUCE look-and-feel style, as introduced in 2017. More...

`#include <juce_LookAndFeel_V4.h>`

Inheritance diagram for LookAndFeel_V4:

## Classes
class | ColourScheme
| A struct containing the set of colours to apply to the GUI. More...

## Public Member Functions
| LookAndFeel_V4 ()
| Creates a LookAndFeel_V4 object with a default colour scheme.
| LookAndFeel_V4 (ColourScheme)
| Creates a LookAndFeel_V4 object with a given colour scheme.
| ~LookAndFeel_V4 () override
| Destructor.
void | setColourScheme (ColourScheme)
ColourScheme & | getCurrentColourScheme () noexcept
Button * | createDocumentWindowButton (int) override
void | positionDocumentWindowButtons (DocumentWindow &, int, int, int, int, Button *, Button *, Button *, bool) override
void | drawDocumentWindowTitleBar (DocumentWindow &, Graphics &, int, int, int, int, const Image *, bool) override
Font | getTextButtonFont (TextButton &, int buttonHeight) override
void | drawButtonBackground (Graphics &, Button &, const Colour &backgroundColour, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
void | drawToggleButton (Graphics &, ToggleButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws the contents of a standard ToggleButton.
void | drawTickBox (Graphics &, Component &, float x, float y, float w, float h, bool ticked, bool isEnabled, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
void | changeToggleButtonWidthToFitText (ToggleButton &) override
AlertWindow * | createAlertWindow (const String &title, const String &message, const String &button1, const String &button2, const String &button3, MessageBoxIconType iconType, int numButtons, Component *associatedComponent) override
void | drawAlertBox (Graphics &, AlertWindow &, const Rectangle< int > &textArea, TextLayout &) override
int | getAlertWindowButtonHeight () override
Font | getAlertWindowTitleFont () override
| Override this function to supply a custom font for the alert window title.
Font | getAlertWindowMessageFont () override
| Override this function to supply a custom font for the alert window message.
Font | getAlertWindowFont () override
void | drawProgressBar (Graphics &, ProgressBar &, int width, int height, double progress, const String &) override
| Draws a progress bar.
bool | isProgressBarOpaque (ProgressBar &) override
ProgressBar::Style | getDefaultProgressBarStyle (const ProgressBar &) override
| Returns the default style a progress bar should use if one hasn't been set.
int | getDefaultScrollbarWidth () override
| Returns the default thickness to use for a scrollbar.
void | drawScrollbar (Graphics &, ScrollBar &, int x, int y, int width, int height, bool isScrollbarVertical, int thumbStartPosition, int thumbSize, bool isMouseOver, bool isMouseDown) override
| Draws the thumb area of a scrollbar.
Path | getTickShape (float height) override
| Returns a tick shape for use in yes/no boxes, etc.
Path | getCrossShape (float height) override
| Returns a cross shape for use in yes/no boxes, etc.
void | fillTextEditorBackground (Graphics &, int width, int height, TextEditor &) override
void | drawTextEditorOutline (Graphics &, int width, int height, TextEditor &) override
Button * | createFileBrowserGoUpButton () override
void | layoutFileBrowserComponent (FileBrowserComponent &, DirectoryContentsDisplayComponent *, FilePreviewComponent *, ComboBox *currentPathBox, TextEditor *filenameBox, Button *goUpButton) override
void | drawFileBrowserRow (Graphics &, int width, int height, const File &file, const String &filename, Image *icon, const String &fileSizeDescription, const String &fileTimeDescription, bool isDirectory, bool isItemSelected, int itemIndex, DirectoryContentsDisplayComponent &) override
void | drawPopupMenuItem (Graphics &, const Rectangle< int > &area, bool isSeparator, bool isActive, bool isHighlighted, bool isTicked, bool hasSubMenu, const String &text, const String &shortcutKeyText, const Drawable *icon, const Colour *textColour) override
| Draws one of the items in a popup menu.
void | getIdealPopupMenuItemSize (const String &text, bool isSeparator, int standardMenuItemHeight, int &idealWidth, int &idealHeight) override
| Finds the best size for an item in a popup menu.
void | drawMenuBarBackground (Graphics &, int width, int height, bool isMouseOverBar, MenuBarComponent &) override
void | drawMenuBarItem (Graphics &, int width, int height, int itemIndex, const String &itemText, bool isMouseOverItem, bool isMenuOpen, bool isMouseOverBar, MenuBarComponent &) override
void | drawComboBox (Graphics &, int width, int height, bool isButtonDown, int buttonX, int buttonY, int buttonW, int buttonH, ComboBox &) override
Font | getComboBoxFont (ComboBox &) override
void | positionComboBoxText (ComboBox &, Label &) override
int | getSliderThumbRadius (Slider &) override
void | drawLinearSlider (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, Slider::SliderStyle, Slider &) override
void | drawRotarySlider (Graphics &, int x, int y, int width, int height, float sliderPosProportional, float rotaryStartAngle, float rotaryEndAngle, Slider &) override
void | drawPointer (Graphics &, float x, float y, float diameter, const Colour &, int direction) noexcept
Label * | createSliderTextBox (Slider &) override
void | drawTooltip (Graphics &, const String &text, int width, int height) override
void | drawConcertinaPanelHeader (Graphics &, const Rectangle< int > &area, bool isMouseOver, bool isMouseDown, ConcertinaPanel &, Component &panel) override
void | drawLevelMeter (Graphics &, int, int, float) override
void | paintToolbarBackground (Graphics &, int width, int height, Toolbar &) override
void | paintToolbarButtonLabel (Graphics &, int x, int y, int width, int height, const String &text, ToolbarItemComponent &) override
void | drawPropertyPanelSectionHeader (Graphics &, const String &name, bool isOpen, int width, int height) override
void | drawPropertyComponentBackground (Graphics &, int width, int height, PropertyComponent &) override
void | drawPropertyComponentLabel (Graphics &, int width, int height, PropertyComponent &) override
Rectangle< int > | getPropertyComponentContentPosition (PropertyComponent &) override
void | drawCallOutBoxBackground (CallOutBox &, Graphics &, const Path &, Image &) override
void | drawStretchableLayoutResizerBar (Graphics &, int, int, bool, bool, bool) override
Public Member Functions inherited from LookAndFeel_V3
| LookAndFeel_V3 ()
| ~LookAndFeel_V3 () override
void | drawTableHeaderBackground (Graphics &, TableHeaderComponent &) override
void | drawTreeviewPlusMinusBox (Graphics &, const Rectangle< float > &area, Colour backgroundColour, bool isOpen, bool isMouseOver) override
bool | areLinesDrawnForTreeView (TreeView &) override
int | getTreeViewIndentSize (TreeView &) override
void | drawKeymapChangeButton (Graphics &, int width, int height, Button &button, const String &keyDescription) override
void | drawPopupMenuBackground (Graphics &, int width, int height) override
| Fills the background of a popup menu component.
int | getTabButtonOverlap (int tabDepth) override
int | getTabButtonSpaceAroundImage () override
void | drawTabButton (TabBarButton &, Graphics &, bool isMouseOver, bool isMouseDown) override
void | drawTabAreaBehindFrontButton (TabbedButtonBar &bar, Graphics &g, int w, int h) override
bool | areScrollbarButtonsVisible () override
void | drawLinearSliderBackground (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, Slider::SliderStyle, Slider &) override
Public Member Functions inherited from LookAndFeel_V2
| LookAndFeel_V2 ()
| ~LookAndFeel_V2 () override
void | drawButtonText (Graphics &, TextButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws the text for a TextButton.
int | getTextButtonWidthToFitText (TextButton &, int buttonHeight) override
void | drawDrawableButton (Graphics &, DrawableButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
int | getAlertBoxWindowFlags () override
Array< int > | getWidthsForTextButtons (AlertWindow &, const Array< TextButton * > &) override
void | drawSpinningWaitAnimation (Graphics &, const Colour &colour, int x, int y, int w, int h) override
| Draws a small image that spins to indicate that something's happening.
void | drawScrollbarButton (Graphics &, ScrollBar &, int width, int height, int buttonDirection, bool isScrollbarVertical, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws one of the buttons on a scrollbar.
ImageEffectFilter * | getScrollbarEffect () override
| Returns the component effect to use for a scrollbar.
int | getMinimumScrollbarThumbSize (ScrollBar &) override
| Returns the minimum length in pixels to use for a scrollbar thumb.
int | getScrollbarButtonSize (ScrollBar &) override
| Returns the length in pixels to use for a scrollbar button.
CaretComponent * | createCaretComponent (Component *keyFocusOwner) override
const Drawable * | getDefaultFolderImage () override
const Drawable * | getDefaultDocumentFileImage () override
AttributedString | createFileChooserHeaderText (const String &title, const String &instructions) override
void | drawBubble (Graphics &, BubbleComponent &, const Point< float > &tip, const Rectangle< float > &body) override
| Override this method to draw a speech-bubble pointing at a specific location on the screen.
void | setComponentEffectForBubbleComponent (BubbleComponent &bubbleComponent) override
| Override this method to set effects, such as a drop-shadow, on a BubbleComponent.
void | drawLasso (Graphics &, Component &) override
void | drawPopupMenuBackgroundWithOptions (Graphics &, int width, int height, const PopupMenu::Options &) override
| Fills the background of a popup menu component.
void | drawPopupMenuItemWithOptions (Graphics &, const Rectangle< int > &area, bool isHighlighted, const PopupMenu::Item &item, const PopupMenu::Options &) override
| Draws one of the items in a popup menu.
void | drawPopupMenuSectionHeader (Graphics &, const Rectangle< int > &area, const String &sectionName) override
void | drawPopupMenuSectionHeaderWithOptions (Graphics &, const Rectangle< int > &area, const String &sectionName, const PopupMenu::Options &) override
Font | getPopupMenuFont () override
| Returns the size and style of font to use in popup menus.
void | drawPopupMenuUpDownArrow (Graphics &, int width, int height, bool isScrollUpArrow) override
void | drawPopupMenuUpDownArrowWithOptions (Graphics &, int width, int height, bool isScrollUpArrow, const PopupMenu::Options &) override
void | getIdealPopupMenuItemSizeWithOptions (const String &text, bool isSeparator, int standardMenuItemHeight, int &idealWidth, int &idealHeight, const PopupMenu::Options &) override
| Finds the best size for an item in a popup menu.
int | getMenuWindowFlags () override
void | preparePopupMenuWindow (Component &) override
int | getMenuBarItemWidth (MenuBarComponent &, int itemIndex, const String &itemText) override
Font | getMenuBarFont (MenuBarComponent &, int itemIndex, const String &itemText) override
int | getDefaultMenuBarHeight () override
Component * | getParentComponentForMenuOptions (const PopupMenu::Options &options) override
bool | shouldPopupMenuScaleWithTargetComponent (const PopupMenu::Options &options) override
| Return true if you want your popup menus to scale with the target component's AffineTransform or scale factor.
int | getPopupMenuBorderSize () override
int | getPopupMenuBorderSizeWithOptions (const PopupMenu::Options &) override
void | drawPopupMenuColumnSeparatorWithOptions (Graphics &g, const Rectangle< int > &bounds, const PopupMenu::Options &) override
| Implement this to draw some custom decoration between the columns of the popup menu.
int | getPopupMenuColumnSeparatorWidthWithOptions (const PopupMenu::Options &) override
| Return the amount of space that should be left between popup menu columns.
Label * | createComboBoxTextBox (ComboBox &) override
PopupMenu::Options | getOptionsForComboBoxPopupMenu (ComboBox &, Label &) override
void | drawComboBoxTextWhenNothingSelected (Graphics &, ComboBox &, Label &) override
void | drawLabel (Graphics &, Label &) override
Font | getLabelFont (Label &) override
BorderSize< int > | getLabelBorderSize (Label &) override
void | drawLinearSliderOutline (Graphics &, int x, int y, int width, int height, Slider::SliderStyle, Slider &) override
void | drawLinearSliderThumb (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, Slider::SliderStyle, Slider &) override
Button * | createSliderButton (Slider &, bool isIncrement) override
ImageEffectFilter * | getSliderEffect (Slider &) override
Font | getSliderPopupFont (Slider &) override
int | getSliderPopupPlacement (Slider &) override
Slider::SliderLayout | getSliderLayout (Slider &) override
Rectangle< int > | getTooltipBounds (const String &tipText, Point< int > screenPos, Rectangle< int > parentArea) override
| returns the bounds for a tooltip at the given screen coordinate, constrained within the given desktop area.
Button * | createFilenameComponentBrowseButton (const String &text) override
void | layoutFilenameComponent (FilenameComponent &, ComboBox *filenameBox, Button *browseButton) override
void | drawCornerResizer (Graphics &, int w, int h, bool isMouseOver, bool isMouseDragging) override
void | drawResizableFrame (Graphics &, int w, int h, const BorderSize< int > &) override
void | fillResizableWindowBackground (Graphics &, int w, int h, const BorderSize< int > &, ResizableWindow &) override
void | drawResizableWindowBorder (Graphics &, int w, int h, const BorderSize< int > &border, ResizableWindow &) override
std::unique_ptr< DropShadower > | createDropShadowerForComponent (Component &) override
| Creates a drop-shadower for a given component, if required.
std::unique_ptr< FocusOutline > | createFocusOutlineForComponent (Component &) override
| Creates a focus outline for a given component, if required.
void | drawGroupComponentOutline (Graphics &, int w, int h, const String &text, const Justification &, GroupComponent &) override
int | getTabButtonBestWidth (TabBarButton &, int tabDepth) override
Rectangle< int > | getTabButtonExtraComponentBounds (const TabBarButton &, Rectangle< int > &textArea, Component &extraComp) override
Font | getTabButtonFont (TabBarButton &, float height) override
void | drawTabButtonText (TabBarButton &, Graphics &, bool isMouseOver, bool isMouseDown) override
void | drawTabbedButtonBarBackground (TabbedButtonBar &, Graphics &) override
void | createTabButtonShape (TabBarButton &, Path &, bool isMouseOver, bool isMouseDown) override
void | fillTabButtonShape (TabBarButton &, Graphics &, const Path &, bool isMouseOver, bool isMouseDown) override
Button * | createTabBarExtrasButton () override
void | drawImageButton (Graphics &, Image *, int imageX, int imageY, int imageW, int imageH, const Colour &overlayColour, float imageOpacity, ImageButton &) override
void | drawTableHeaderColumn (Graphics &, TableHeaderComponent &, const String &columnName, int columnId, int width, int height, bool isMouseOver, bool isMouseDown, int columnFlags) override
Button * | createToolbarMissingItemsButton (Toolbar &) override
void | paintToolbarButtonBackground (Graphics &, int width, int height, bool isMouseOver, bool isMouseDown, ToolbarItemComponent &) override
int | getPropertyPanelSectionHeaderHeight (const String &sectionTitle) override
int | getCallOutBoxBorderSize (const CallOutBox &) override
float | getCallOutBoxCornerSize (const CallOutBox &) override
Font | getSidePanelTitleFont (SidePanel &) override
Justification | getSidePanelTitleJustification (SidePanel &) override
Path | getSidePanelDismissButtonShape (SidePanel &) override
Public Member Functions inherited from LookAndFeel
| LookAndFeel ()
| Creates the default JUCE look and feel.
| ~LookAndFeel () override
| Destructor.
Colour | findColour (int colourId) const noexcept
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourId, Colour colour) noexcept
| Registers a colour to be used for a particular purpose.
bool | isColourSpecified (int colourId) const noexcept
| Returns true if the specified colour ID has been explicitly set using the setColour() method.
virtual Typeface::Ptr | getTypefaceForFont (const Font &)
| Returns the typeface that should be used for a given font.
void | setDefaultSansSerifTypeface (Typeface::Ptr newDefaultTypeface)
| Allows you to supply a default typeface that will be returned as the default sans-serif font.
void | setDefaultSansSerifTypefaceName (const String &newName)
| Allows you to change the default sans-serif font.
void | setUsingNativeAlertWindows (bool shouldUseNativeAlerts)
| Sets whether native alert windows (if available) or standard JUCE AlertWindows drawn with AlertWindow::LookAndFeelMethods will be used.
bool | isUsingNativeAlertWindows ()
| Returns true if native alert windows will be used (if available).
virtual MouseCursor | getMouseCursorFor (Component &)
| Override this to get the chance to swap a component's mouse cursor for a customised one.
virtual std::unique_ptr< LowLevelGraphicsContext > | createGraphicsContext (const Image &imageToRenderOn, Point< int > origin, const RectangleList< int > &initialClip)
| Creates a new graphics context object.
virtual void | playAlertSound ()
| Plays the system's default 'beep' noise, to alert the user about something very important.
Public Member Functions inherited from ScrollBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from Button::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from ImageButton::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from TextEditor::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from FileBrowserComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from TreeView::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from BubbleComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from AlertWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from PopupMenu::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from ComboBox::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from Label::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from Slider::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from ResizableWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from DocumentWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from TooltipWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from TabbedButtonBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from PropertyComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from FilenameComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from GroupComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from TableHeaderComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from CallOutBox::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from Toolbar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from ConcertinaPanel::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from ProgressBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from StretchableLayoutResizerBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
Public Member Functions inherited from ExtraLookAndFeelBaseClasses::KeyMappingEditorComponentMethods
virtual | ~KeyMappingEditorComponentMethods ()=default
Public Member Functions inherited from ExtraLookAndFeelBaseClasses::AudioDeviceSelectorComponentMethods
virtual | ~AudioDeviceSelectorComponentMethods ()=default
Public Member Functions inherited from ExtraLookAndFeelBaseClasses::LassoComponentMethods
virtual | ~LassoComponentMethods ()=default
Public Member Functions inherited from SidePanel::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default

## Static Public Member Functions
static ColourScheme | getDarkColourScheme ()
static ColourScheme | getMidnightColourScheme ()
static ColourScheme | getGreyColourScheme ()
static ColourScheme | getLightColourScheme ()
Static Public Member Functions inherited from LookAndFeel_V3
static void | createTabTextLayout (const TabBarButton &button, float length, float depth, Colour colour, TextLayout &)
Static Public Member Functions inherited from LookAndFeel_V2
static void | drawBevel (Graphics &, int x, int y, int width, int height, int bevelThickness, const Colour &topLeftColour=Colours::white, const Colour &bottomRightColour=Colours::black, bool useGradient=true, bool sharpEdgeOnOutside=true)
| Draws a 3D raised (or indented) bevel using two colours.
static void | drawGlassSphere (Graphics &, float x, float y, float diameter, const Colour &, float outlineThickness) noexcept
| Utility function to draw a shiny, glassy circle (for round LED-type buttons).
static void | drawGlassPointer (Graphics &, float x, float y, float diameter, const Colour &, float outlineThickness, int direction) noexcept
static void | drawGlassLozenge (Graphics &, float x, float y, float width, float height, const Colour &, float outlineThickness, float cornerSize, bool flatOnLeft, bool flatOnRight, bool flatOnTop, bool flatOnBottom) noexcept
| Utility function to draw a shiny, glassy oblong (for text buttons).
Static Public Member Functions inherited from LookAndFeel
static LookAndFeel & | getDefaultLookAndFeel () noexcept
| Returns the current default look-and-feel for a component to use when it hasn't got one explicitly set.
static void | setDefaultLookAndFeel (LookAndFeel *newDefaultLookAndFeel) noexcept
| Changes the default look-and-feel.

## Detailed Description

The latest JUCE look-and-feel style, as introduced in 2017.

See also
  LookAndFeel, LookAndFeel_V1, LookAndFeel_V2, LookAndFeel_V3

## Constructor & Destructor Documentation

## ◆ LookAndFeel_V4() [1/2]

LookAndFeel_V4::LookAndFeel_V4 | ( |  | ) |

Creates a LookAndFeel_V4 object with a default colour scheme.

## ◆ LookAndFeel_V4() [2/2]

LookAndFeel_V4::LookAndFeel_V4 | ( | ColourScheme |  | ) |

Creates a LookAndFeel_V4 object with a given colour scheme.

## ◆ ~LookAndFeel_V4()

LookAndFeel_V4::~LookAndFeel_V4 | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ setColourScheme()

void LookAndFeel_V4::setColourScheme | ( | ColourScheme |  | ) |

## ◆ getCurrentColourScheme()

ColourScheme & LookAndFeel_V4::getCurrentColourScheme | ( |  | ) |
| noexcept

## ◆ getDarkColourScheme()

static ColourScheme LookAndFeel_V4::getDarkColourScheme | ( |  | ) |
| static

## ◆ getMidnightColourScheme()

static ColourScheme LookAndFeel_V4::getMidnightColourScheme | ( |  | ) |
| static

## ◆ getGreyColourScheme()

static ColourScheme LookAndFeel_V4::getGreyColourScheme | ( |  | ) |
| static

## ◆ getLightColourScheme()

static ColourScheme LookAndFeel_V4::getLightColourScheme | ( |  | ) |
| static

## ◆ createDocumentWindowButton()

Button * LookAndFeel_V4::createDocumentWindowButton | ( | int |  | ) |
| overridevirtual

Reimplemented from LookAndFeel_V3.

## ◆ positionDocumentWindowButtons()

void LookAndFeel_V4::positionDocumentWindowButtons | ( | DocumentWindow & | ,
|  | int | ,
|  | int | ,
|  | int | ,
|  | int | ,
|  | Button * | ,
|  | Button * | ,
|  | Button * | ,
|  | bool | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawDocumentWindowTitleBar()

void LookAndFeel_V4::drawDocumentWindowTitleBar | ( | DocumentWindow & | ,
|  | Graphics & | ,
|  | int | ,
|  | int | ,
|  | int | ,
|  | int | ,
|  | const Image * | ,
|  | bool | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ getTextButtonFont()

Font LookAndFeel_V4::getTextButtonFont | ( | TextButton & | ,
|  | int | buttonHeight )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawButtonBackground()

void LookAndFeel_V4::drawButtonBackground | ( | Graphics & | ,
|  | Button & | ,
|  | const Colour & | backgroundColour,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown )
| overridevirtual

Reimplemented from LookAndFeel_V3.

## ◆ drawToggleButton()

void LookAndFeel_V4::drawToggleButton | ( | Graphics & | ,
|  | ToggleButton & | ,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown )
| overridevirtual

Draws the contents of a standard ToggleButton.

Reimplemented from LookAndFeel_V2.

## ◆ drawTickBox()

void LookAndFeel_V4::drawTickBox | ( | Graphics & | ,
|  | Component & | ,
|  | float | x,
|  | float | y,
|  | float | w,
|  | float | h,
|  | bool | ticked,
|  | bool | isEnabled,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ changeToggleButtonWidthToFitText()

void LookAndFeel_V4::changeToggleButtonWidthToFitText | ( | ToggleButton & |  | ) |
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ createAlertWindow()

AlertWindow * LookAndFeel_V4::createAlertWindow | ( | const String & | title,
|  | const String & | message,
|  | const String & | button1,
|  | const String & | button2,
|  | const String & | button3,
|  | MessageBoxIconType | iconType,
|  | int | numButtons,
|  | Component * | associatedComponent )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawAlertBox()

void LookAndFeel_V4::drawAlertBox | ( | Graphics & | ,
|  | AlertWindow & | ,
|  | const Rectangle< int > & | textArea,
|  | TextLayout & | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ getAlertWindowButtonHeight()

int LookAndFeel_V4::getAlertWindowButtonHeight | ( |  | ) |
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ getAlertWindowTitleFont()

Font LookAndFeel_V4::getAlertWindowTitleFont | ( |  | ) |
| overridevirtual

Override this function to supply a custom font for the alert window title.

This default implementation will use a boldened and slightly larger version of the alert window message font.

See also
  getAlertWindowMessageFont.

Reimplemented from LookAndFeel_V2.

## ◆ getAlertWindowMessageFont()

Font LookAndFeel_V4::getAlertWindowMessageFont | ( |  | ) |
| overridevirtual

Override this function to supply a custom font for the alert window message.

This default implementation will use the default font with height set to 15.0f.

See also
  getAlertWindowTitleFont

Reimplemented from LookAndFeel_V2.

## ◆ getAlertWindowFont()

Font LookAndFeel_V4::getAlertWindowFont | ( |  | ) |
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawProgressBar()

void LookAndFeel_V4::drawProgressBar | ( | Graphics & | ,
|  | ProgressBar & | ,
|  | int | width,
|  | int | height,
|  | double | progress,
|  | const String & | textToShow )
| overridevirtual

Draws a progress bar.

If the progress value is less than 0 or greater than 1.0, this should draw a spinning bar that fills the whole space (i.e. to say that the app is still busy but the progress isn't known). It can use the current time as a basis for playing an animation.

To determine which style of progress-bar to draw call getResolvedStyle().

(Used by progress bars in AlertWindow).

See also
  getResolvedStyle

Reimplemented from LookAndFeel_V2.

## ◆ isProgressBarOpaque()

bool LookAndFeel_V4::isProgressBarOpaque | ( | ProgressBar & |  | ) |
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ getDefaultProgressBarStyle()

ProgressBar::Style LookAndFeel_V4::getDefaultProgressBarStyle | ( | const ProgressBar & |  | ) |
| overridevirtual

Returns the default style a progress bar should use if one hasn't been set.

See also
  setStyle, getResolvedStyle

Reimplemented from LookAndFeel_V2.

## ◆ getDefaultScrollbarWidth()

int LookAndFeel_V4::getDefaultScrollbarWidth | ( |  | ) |
| overridevirtual

Returns the default thickness to use for a scrollbar.

Reimplemented from LookAndFeel_V2.

## ◆ drawScrollbar()

void LookAndFeel_V4::drawScrollbar | ( | Graphics & | g,
|  | ScrollBar & | scrollbar,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | bool | isScrollbarVertical,
|  | int | thumbStartPosition,
|  | int | thumbSize,
|  | bool | isMouseOver,
|  | bool | isMouseDown )
| overridevirtual

Draws the thumb area of a scrollbar.

Parameters

  g | the context to draw into
  scrollbar | the bar itself
  x | the x position of the left edge of the thumb area to draw in
  y | the y position of the top edge of the thumb area to draw in
  width | the width of the thumb area to draw in
  height | the height of the thumb area to draw in
  isScrollbarVertical | true if it's a vertical bar, false if horizontal
  thumbStartPosition | for vertical bars, the y coordinate of the top of the thumb, or its x position for horizontal bars
  thumbSize | for vertical bars, the height of the thumb, or its width for horizontal bars. This may be 0 if the thumb shouldn't be drawn.
  isMouseOver | whether the mouse is over the thumb area, also true if the mouse is currently dragging the thumb
  isMouseDown | whether the mouse is currently dragging the scrollbar

Reimplemented from LookAndFeel_V3.

## ◆ getTickShape()

Path LookAndFeel_V4::getTickShape | ( | float | height | ) |
| overridevirtual

Returns a tick shape for use in yes/no boxes, etc.

Reimplemented from LookAndFeel_V3.

## ◆ getCrossShape()

Path LookAndFeel_V4::getCrossShape | ( | float | height | ) |
| overridevirtual

Returns a cross shape for use in yes/no boxes, etc.

Reimplemented from LookAndFeel_V3.

## ◆ fillTextEditorBackground()

void LookAndFeel_V4::fillTextEditorBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | TextEditor & | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawTextEditorOutline()

void LookAndFeel_V4::drawTextEditorOutline | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | TextEditor & | )
| overridevirtual

Reimplemented from LookAndFeel_V3.

## ◆ createFileBrowserGoUpButton()

Button * LookAndFeel_V4::createFileBrowserGoUpButton | ( |  | ) |
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ layoutFileBrowserComponent()

void LookAndFeel_V4::layoutFileBrowserComponent | ( | FileBrowserComponent & | ,
|  | DirectoryContentsDisplayComponent * | ,
|  | FilePreviewComponent * | ,
|  | ComboBox * | currentPathBox,
|  | TextEditor * | filenameBox,
|  | Button * | goUpButton )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawFileBrowserRow()

void LookAndFeel_V4::drawFileBrowserRow | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | const File & | file,
|  | const String & | filename,
|  | Image * | icon,
|  | const String & | fileSizeDescription,
|  | const String & | fileTimeDescription,
|  | bool | isDirectory,
|  | bool | isItemSelected,
|  | int | itemIndex,
|  | DirectoryContentsDisplayComponent & | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawPopupMenuItem()

void LookAndFeel_V4::drawPopupMenuItem | ( | Graphics & | ,
|  | const Rectangle< int > & | area,
|  | bool | isSeparator,
|  | bool | isActive,
|  | bool | isHighlighted,
|  | bool | isTicked,
|  | bool | hasSubMenu,
|  | const String & | text,
|  | const String & | shortcutKeyText,
|  | const Drawable * | icon,
|  | const Colour * | textColour )
| overridevirtual

Draws one of the items in a popup menu.

Reimplemented from LookAndFeel_V2.

## ◆ getIdealPopupMenuItemSize()

void LookAndFeel_V4::getIdealPopupMenuItemSize | ( | const String & | text,
|  | bool | isSeparator,
|  | int | standardMenuItemHeight,
|  | int & | idealWidth,
|  | int & | idealHeight )
| overridevirtual

Finds the best size for an item in a popup menu.

Reimplemented from LookAndFeel_V2.

## ◆ drawMenuBarBackground()

void LookAndFeel_V4::drawMenuBarBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isMouseOverBar,
|  | MenuBarComponent & | )
| overridevirtual

Reimplemented from LookAndFeel_V3.

## ◆ drawMenuBarItem()

void LookAndFeel_V4::drawMenuBarItem | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | int | itemIndex,
|  | const String & | itemText,
|  | bool | isMouseOverItem,
|  | bool | isMenuOpen,
|  | bool | isMouseOverBar,
|  | MenuBarComponent & | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawComboBox()

void LookAndFeel_V4::drawComboBox | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isButtonDown,
|  | int | buttonX,
|  | int | buttonY,
|  | int | buttonW,
|  | int | buttonH,
|  | ComboBox & | )
| overridevirtual

Reimplemented from LookAndFeel_V3.

## ◆ getComboBoxFont()

Font LookAndFeel_V4::getComboBoxFont | ( | ComboBox & |  | ) |
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ positionComboBoxText()

void LookAndFeel_V4::positionComboBoxText | ( | ComboBox & | ,
|  | Label & | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ getSliderThumbRadius()

int LookAndFeel_V4::getSliderThumbRadius | ( | Slider & |  | ) |
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawLinearSlider()

void LookAndFeel_V4::drawLinearSlider | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | float | sliderPos,
|  | float | minSliderPos,
|  | float | maxSliderPos,
|  | Slider::SliderStyle | ,
|  | Slider & | )
| overridevirtual

Reimplemented from LookAndFeel_V3.

## ◆ drawRotarySlider()

void LookAndFeel_V4::drawRotarySlider | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | float | sliderPosProportional,
|  | float | rotaryStartAngle,
|  | float | rotaryEndAngle,
|  | Slider & | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawPointer()

void LookAndFeel_V4::drawPointer | ( | Graphics & | ,
|  | float | x,
|  | float | y,
|  | float | diameter,
|  | const Colour & | ,
|  | int | direction )
| noexcept

## ◆ createSliderTextBox()

Label * LookAndFeel_V4::createSliderTextBox | ( | Slider & |  | ) |
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawTooltip()

void LookAndFeel_V4::drawTooltip | ( | Graphics & | ,
|  | const String & | text,
|  | int | width,
|  | int | height )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawConcertinaPanelHeader()

void LookAndFeel_V4::drawConcertinaPanelHeader | ( | Graphics & | ,
|  | const Rectangle< int > & | area,
|  | bool | isMouseOver,
|  | bool | isMouseDown,
|  | ConcertinaPanel & | ,
|  | Component & | panel )
| overridevirtual

Reimplemented from LookAndFeel_V3.

## ◆ drawLevelMeter()

void LookAndFeel_V4::drawLevelMeter | ( | Graphics & | ,
|  | int | ,
|  | int | ,
|  | float | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ paintToolbarBackground()

void LookAndFeel_V4::paintToolbarBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | Toolbar & | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ paintToolbarButtonLabel()

void LookAndFeel_V4::paintToolbarButtonLabel | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | const String & | text,
|  | ToolbarItemComponent & | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawPropertyPanelSectionHeader()

void LookAndFeel_V4::drawPropertyPanelSectionHeader | ( | Graphics & | ,
|  | const String & | name,
|  | bool | isOpen,
|  | int | width,
|  | int | height )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawPropertyComponentBackground()

void LookAndFeel_V4::drawPropertyComponentBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | PropertyComponent & | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawPropertyComponentLabel()

void LookAndFeel_V4::drawPropertyComponentLabel | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | PropertyComponent & | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ getPropertyComponentContentPosition()

Rectangle< int > LookAndFeel_V4::getPropertyComponentContentPosition | ( | PropertyComponent & |  | ) |
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawCallOutBoxBackground()

void LookAndFeel_V4::drawCallOutBoxBackground | ( | CallOutBox & | ,
|  | Graphics & | ,
|  | const Path & | ,
|  | Image & | )
| overridevirtual

Reimplemented from LookAndFeel_V2.

## ◆ drawStretchableLayoutResizerBar()

void LookAndFeel_V4::drawStretchableLayoutResizerBar | ( | Graphics & | ,
|  | int | ,
|  | int | ,
|  | bool | ,
|  | bool | ,
|  | bool | )
| overridevirtual

Reimplemented from LookAndFeel_V3.

The documentation for this class was generated from the following file:

- juce_LookAndFeel_V4.h